#include  <stdio.h>
#include  <stdlib.h>
#include <string.h>
int main(int n ,char * argv[])
{
long GetFileSize(char *filename);
char *filename;
char *Flag;
char *filejt="jt.txt";
char *fileft="ft.txt";
char *testChar="你";
int baseCharLen;//定义操作系统上一个中文字符的长度
int fileLen,jtLen,ftLen;
FILE *fft,*fjt,*fcontent;
//////////////////////////

printf("\n------------------------------v0.2使用方法！------------------------------\n\n");
printf("\n使用方法：    zw-convert cn/tw  文件名\n\n cn为繁体转换简体，tw为简体转换繁体。\n\n本软件只是将相应的简体/繁体文字替换，并不进行编码转换，注意使用时的编码问题。");
	if(n>1)
	{
	
	Flag=argv[1];
	filename=argv[2];
	//printf("\nFlag : %s\n",Flag);
	//printf("\nfilename : %s \n",filename);
	
	/////////////////////////////////////////////////////
	
	baseCharLen=strlen(testChar);//取得操作系统上一个中文字符的长度
	printf("\n\n在本操作系统上一个汉字长度为：%d\n",baseCharLen);

	//////////////////////////////////////
	
	fileLen=GetFileSize(filename); //取得要转换的文件的大小
	jtLen=GetFileSize(filejt); //取得简体字码表的大小
	ftLen=GetFileSize(fileft); //取得繁体字码表的大小
	printf("\n\n文件长度为 : %d\n",fileLen);
	char contentChar[fileLen];//要替换的字  分配存贮大小
	char ft[ftLen]; 
	char jt[jtLen];
	
	/////////////////////////////////////////
	if(jtLen!=ftLen)
	{
		printf("简体字码表和繁体字码表长度不一致，可能导致转换失败！");
	}

////////////////////////////////////////////////////////
	if((fft=fopen(fileft,"r+"))==NULL)//读入繁体字码表
	{
		printf("\n %s is not find!  Or  canot open file!\n",fileft);
		printf("\n请检查目录下繁体字码表是否存在！文件名为ft.txt");
		printf("\n------------------------------使用方法！------------------------------\n\n");
printf("\n使用方法：    zw-convert cn/tw  文件名\n\n cn为繁体转换简体，tw为简体转换繁体。\n\n本软件只是将相应的简体/繁体文字替换，并不进行编码转换，注意使用时的编码问题。");
		exit(0);
	}
	fgets(ft,ftLen,fft);
	//printf(" \n繁体字码表： \n\n%s\n",ft);
	fclose(fft);
	
	///////////////////////////////////////////
	
	if((fjt=fopen(filejt,"r+"))==NULL)//读入简体字码表
	{
		printf("\n %s is not find!  Or  canot open file!\n",filejt);
		printf("\n请检查目录下简体字码表是否存在！文件名为jt.txt");
		printf("\n------------------------------使用方法！------------------------------\n\n");
printf("\n使用方法：    zw-convert cn/tw  文件名\n\n cn为繁体转换简体，tw为简体转换繁体。\n\n本软件只是将相应的简体/繁体文字替换，并不进行编码转换，注意使用时的编码问题。");
		exit(0);
	}
	fgets(jt,jtLen,fjt);
	//printf("\n 简体字码表：\n\n%s\n",jt);
	fclose(fjt);
	
///////////////////////////////////////////////////////


	if((fcontent=fopen(filename,"r+"))==NULL)//读入要转换的文件
	{
		printf("\n %s is not find!  Or canot open file!\n",filename);
		printf("\n------------------------------使用方法！------------------------------\n\n");
printf("\n使用方法：    zw-convert cn/tw  文件名  \n\n cn为繁体转换简体，tw为简体转换繁体。\n\n本软件只是将相应的简体/繁体文字替换，并不进行编码转换，注意使用时的编码问题。");
		exit(0);
	}
//	fgets(contentChar,fileLen,fcontent);
	fread(contentChar,fileLen,1,fcontent);
	//printf("\n 要转换的文件内容 ： \n\n%s\n",contentChar);
	fclose(fcontent);	
	////////////////////////////////////////////
	
	if(strcmp(Flag,"tw")==0)
	{
		/*
	将简体字码表中的简体字挨个与欲转换的文件内容比较，如果相同，则将文件中相应的简体字替换为繁体字
	*/
	printf("\n\n简体--》繁体\n\n");
	
	int i,j;//简体--》繁体
	for(i=0;i<=ftLen;i=i+baseCharLen)
	{
		for(j=0;j<=fileLen;j++)
		{
			if(jt[i]==contentChar[j]&&jt[i+1]==contentChar[j+1]&&jt[i+2]==contentChar[j+2])
			{
				contentChar[j]=ft[i];
				contentChar[j+1]=ft[i+1];
				contentChar[j+2]=ft[i+2];
			}
		}
	
	}
	printf("\n\n转换完成！\n\n %s",contentChar);
	fcontent=fopen(strcat(filename,"_tw"),"w+");//写入文件,在原文件名后追加tw表示转换后的繁体文件
	fwrite(contentChar,fileLen,1,fcontent);
	fclose(fcontent);	
	printf("写入完成！");
	}else if(strcmp(Flag,"cn")==0)
	{
	/*
	将繁体字码表中的繁体字挨个与欲转换的文件内容比较，如果相同，则将文件中相应的繁体字替换为简体字
	*/
	printf("\n\n繁体--》简体\n\n");
	
	int i,j;//繁体--》简体
	for(i=0;i<=jtLen;i=i+baseCharLen)
	{
		for(j=0;j<=fileLen;j++)
		{
			if(ft[i]==contentChar[j]&&ft[i+1]==contentChar[j+1]&&ft[i+2]==contentChar[j+2])
			{
				contentChar[j]=jt[i];
				contentChar[j+1]=jt[i+1];
				contentChar[j+2]=jt[i+2];
			}
		}
	
	}
	printf("\n\n转换完成！\n\n %s",contentChar);
	fcontent=fopen(strcat(filename,"_cn"),"w+");//写入文件,在原文件名后追加cn表示转换后的简体文件
	fwrite(contentChar,fileLen,1,fcontent);
	fclose(fcontent);	
	printf("写入完成！");
	
	}else{
	
	printf("参数错误！");
	printf("\n------------------------------使用方法！------------------------------\n\n");
printf("\n使用方法：    zw-convert cn/tw  文件名\n\n cn为繁体转换简体，tw为简体转换繁体。\n\n本软件只是将相应的简体/繁体文字替换，并不进行编码转换，注意使用时的编码问题。");
	}
	
	//////////////////////////////////////////////
	
	}else
	{
	exit(0);
	
	}
	
return 0;
}


//////////////////////////////////////////////


long GetFileSize(char *filename)
{
long siz = 0;
FILE *fp = fopen(filename, "rb");
if (fp) {
fseek(fp, 0, SEEK_END);
siz = ftell(fp);
fclose(fp);
}
return siz;
}

